package com.persagy.dmp.admin.config.shiro;

import lombok.extern.slf4j.Slf4j;
import org.apache.shiro.authz.AuthorizationException;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestControllerAdvice;

import java.util.HashMap;
import java.util.Map;

@Slf4j
@RestControllerAdvice
public class ShiroExceptionHandler {

	@ResponseBody
	@ExceptionHandler(AuthorizationException.class)
	public Map<String, Object> businessInterfaceException(AuthorizationException e) {
		log.error("exception handler : {} {}", e.getClass().getName(), e.getMessage());
		Map<String, Object> result = new HashMap<>();
		result.put("result", "unauthorization");
		result.put("message", "无权操作");
		return result;
	}

}
