package com.persagy.dmp.admin.service.trans;

import lombok.Getter;
import lombok.Setter;

import java.util.HashMap;
import java.util.LinkedList;
import java.util.List;
import java.util.Map;

/**
 * @author: yaoll
 * @date: 2020-12-01
 * @verison: 1.0
 */
public class GraphMapping {

	private static final List<Item> mappings = new LinkedList<>();

	static {
		init();
	}

	public static void init() {
		// 新版定义,无映射
		Map<String, Item> map = new HashMap<>();
		List<Item> baseLise = getBaseLise();
		mappings.addAll(baseLise);

		// 映射
		List<Item> oldList = getOldMappingList();
		mappings.addAll(oldList);

		// 特殊的
		List<Item> oldMappingListWithRelValue = getOldMappingListWithRelValue();
		mappings.addAll(oldMappingListWithRelValue);
	}

	private static List<Item> getBaseLise() {
		List<Item> list = new LinkedList<>();
		list.add(new Item("ArchSubset", "Pj2Bd"));
		list.add(new Item("ArchSubset", "Bd2Fl"));
		list.add(new Item("ArchSubset", "Bd2Sh"));
		list.add(new Item("ArchSubset", "Bd2Sp"));
		list.add(new Item("ArchSubset", "Fl2Sp"));
		list.add(new Item("ArchSubset", "Sh2Sp"));
		list.add(new Item("SpaceNeighborhood", "None"));
		list.add(new Item("SpaceNeighborhood", "Door"));
		list.add(new Item("SpaceNeighborhood", "Window"));
		list.add(new Item("SpaceNeighborhood", "DoorWindow"));
		list.add(new Item("SpaceNeighborhood", "Connect"));
		list.add(new Item("ThroughRelationship", "Fl2Fl"));
		list.add(new Item("ThroughRelationship", "Sh2Sh"));
		list.add(new Item("TrafficNetwork", "Normal"));
		list.add(new Item("TrafficNetwork", "FFOpen"));
		list.add(new Item("TrafficNetwork", "FFClose"));
		list.add(new Item("ConvectionNetwork", "Natural"));
		list.add(new Item("ConvectionNetwork", "OnewayMech"));
		list.add(new Item("ConvectionNetwork", "MixMech"));
		list.add(new Item("RadiationNetwork", "Connect"));
		list.add(new Item("RadiationNetwork", "Transparent"));
		list.add(new Item("MechInArch", "Sy2Bd"));
		list.add(new Item("MechInArch", "Sy2Fl"));
		list.add(new Item("MechInArch", "Sy2Sh"));
		list.add(new Item("MechInArch", "Sy2Sp"));
		list.add(new Item("MechInArch", "Eq2Bd"));
		list.add(new Item("MechInArch", "Eq2Fl"));
		list.add(new Item("MechInArch", "Eq2Sh"));
		list.add(new Item("MechInArch", "Eq2Sp"));
		list.add(new Item("MechForArch", "Sy2Bd"));
		list.add(new Item("MechForArch", "Sy2Fl"));
		list.add(new Item("MechForArch", "Sy2Sh"));
		list.add(new Item("MechForArch", "Sy2Sp"));
		list.add(new Item("MechForArch", "Eq2Bd"));
		list.add(new Item("MechForArch", "Eq2Fl"));
		list.add(new Item("MechForArch", "Eq2Sh"));
		list.add(new Item("MechForArch", "Eq2Sp"));
		list.add(new Item("MechSubset", "Pj2Sy"));
		list.add(new Item("MechSubset", "Pj2Eq"));
		list.add(new Item("MechSubset", "Sy2Eq"));
		list.add(new Item("MechSubset", "Eq2Ec"));
		list.add(new Item("LUDistribution", "Normal"));
		list.add(new Item("LUDistribution", "Backup"));
		list.add(new Item("HUDistribution", "Normal"));
		list.add(new Item("HUDistribution", "Backup"));
		list.add(new Item("ChillWaterLoop", "Supply"));
		list.add(new Item("ChillWaterLoop", "Return"));
		list.add(new Item("ChillWaterLoop", "Bypass"));
		list.add(new Item("ChillWaterLoop", "Fill"));
		list.add(new Item("CoolingWaterLoop", "Supply"));
		list.add(new Item("CoolingWaterLoop", "Return"));
		list.add(new Item("CoolingWaterLoop", "Bypass"));
		list.add(new Item("CoolingWaterLoop", "Fill"));
		list.add(new Item("HeatWaterLoop", "Supply"));
		list.add(new Item("HeatWaterLoop", "Return"));
		list.add(new Item("HeatWaterLoop", "Bypass"));
		list.add(new Item("HeatWaterLoop", "Fill"));
		list.add(new Item("CondWaterNetwork", "Discharge"));
		list.add(new Item("ACAirNetwork", "Supply"));
		list.add(new Item("ACAirNetwork", "Return"));
		list.add(new Item("ACAirNetwork", "Discharge"));
		list.add(new Item("FreshAirNetwork", "Fresh"));
		list.add(new Item("VentNetwork", "Supply"));
		list.add(new Item("VentNetwork", "Discharge"));
		list.add(new Item("VentNetwork", "Uncertain"));
		list.add(new Item("VRFNetwork", "SupplyReturn"));
		list.add(new Item("DomesticWaterNetwork", "Supply"));
		list.add(new Item("DomesticWaterNetwork", "Bypass"));
		list.add(new Item("DrainingWaterNetwork", "Discharge"));
		list.add(new Item("DrainingWaterNetwork", "Bypass"));
		list.add(new Item("RecycleWaterNetwork", "Supply"));
		list.add(new Item("RecycleWaterNetwork", "Bypass"));
		list.add(new Item("DrinkingWaterNetwork", "Supply"));
		list.add(new Item("DrinkingWaterNetwork", "Bypass"));
		list.add(new Item("DHWNetwork", "Supply"));
		list.add(new Item("DHWNetwork", "Bypass"));
		list.add(new Item("GasNetwork", "Supply"));
		list.add(new Item("GasNetwork", "Bypass"));
		list.add(new Item("FireWaterNetwork", "Supply"));
		list.add(new Item("FireWaterNetwork", "Bypass"));
		list.add(new Item("FireVentNetwork", "Discharge"));
		list.add(new Item("WENetwork", "Normal"));
		list.add(new Item("MechCtrl", "SyCtrl"));
		list.add(new Item("MechCtrl", "EqCtrl"));
		list.add(new Item("MechPower", "SyNormal"));
		list.add(new Item("MechPower", "SyBackup"));
		list.add(new Item("MechPower", "EqNormal"));
		list.add(new Item("MechPower", "EqBackup"));
		list.add(new Item("SensorRelationship", "Ss2Eq"));
		list.add(new Item("SensorRelationship", "Ss2Sy"));
		list.add(new Item("SensorRelationship", "Ss2Sp"));
		list.add(new Item("ValveRelationship", "Vv2Eq"));
		list.add(new Item("ValveRelationship", "Vv2Sy"));
		list.add(new Item("EnergySubMeter", "Em2Bd"));
		list.add(new Item("EnergySubMeter", "Sub2Em"));
		list.add(new Item("EnergySubMeter", "SubTree"));
		list.add(new Item("EnergySubMeter", "Br2Sub"));
		list.add(new Item("EnergySubMeter", "Br2Eq"));
		list.add(new Item("ScheduleRelationship", "Sch2Pj"));
		list.add(new Item("ScheduleRelationship", "Sch2Bd"));
		list.add(new Item("ScheduleRelationship", "Sch2Fl"));
		list.add(new Item("ScheduleRelationship", "Sch2Sp"));
		list.add(new Item("ScheduleRelationship", "Sch2Tn"));
		list.add(new Item("MeteorologyRelationship", "Ms2Pj"));
		list.add(new Item("TenentInArch", "Tn2Sp"));
		list.add(new Item("Property2Mech", "Pe2Eq"));
		list.add(new Item("Property2Mech", "Pe2Ec"));
		list.add(new Item("PropertyInArch", "Pe2Pj"));
		list.add(new Item("PropertyInArch", "Pe2Bd"));
		list.add(new Item("PropertyInArch", "Pe2Fl"));
		list.add(new Item("PropertyInArch", "Pe2Sh"));
		list.add(new Item("PropertyInArch", "Pe2Sp"));

		list.add(new Item("ArchForArch", "Bd2Bd"));
		list.add(new Item("ArchForArch", "Bd2Fl"));
		list.add(new Item("ArchForArch", "Bd2Sh"));
		list.add(new Item("ArchForArch", "Bd2Sp"));
		list.add(new Item("ArchForArch", "Fl2Bd"));
		list.add(new Item("ArchForArch", "Fl2Fl"));
		list.add(new Item("ArchForArch", "Fl2Sh"));
		list.add(new Item("ArchForArch", "Fl2Sp"));
		list.add(new Item("ArchForArch", "Sh2Bd"));
		list.add(new Item("ArchForArch", "Sh2Fl"));
		list.add(new Item("ArchForArch", "Sh2Sh"));
		list.add(new Item("ArchForArch", "Sh2Sp"));
		list.add(new Item("ArchForArch", "Sp2Bd"));
		list.add(new Item("ArchForArch", "Sp2Fl"));
		list.add(new Item("ArchForArch", "Sp2Sh"));
		list.add(new Item("ArchForArch", "Sp2Sp"));
		return list;
	}

	private static List<Item> getOldMappingList() {
		List<Item> list = new LinkedList<>();
		list.add(new Item("ArchSubset", "Bd2Fl", "Subset", "1", "1"));
		list.add(new Item("ArchSubset", "Bd2Sh", "ShaftandBuilding", "1", "1"));
		list.add(new Item("ArchSubset", "Bd2Sp", "Subset", "2", "1"));
		list.add(new Item("ArchSubset", "Fl2Sp", "Subset", "4", "1"));
		list.add(new Item("ArchSubset", "Sh2Sp", "ShaftandSpace", "1", "1"));
		list.add(new Item("MechSubset", "Sy2Eq", "SystemEquip", "1", "1"));
		list.add(new Item("MechSubset", "Eq2Ec", "Subset", "5", "1"));
		list.add(new Item("SpaceNeighborhood", "None", "SpaceNeighborhood", "1", "1"));
		list.add(new Item("SpaceNeighborhood", "Door", "SpaceNeighborhood", "2", "1"));
		list.add(new Item("SpaceNeighborhood", "Window", "SpaceNeighborhood", "3", "1"));
		list.add(new Item("SpaceNeighborhood", "DoorWindow", "SpaceNeighborhood", "4", "1"));
		list.add(new Item("SpaceNeighborhood", "Connect", "SpaceNeighborhood", "5", "1"));
		list.add(new Item("TrafficNetwork", "Normal", "TrafficNetwork", "1", "1"));
		list.add(new Item("TrafficNetwork", "FFOpen", "TrafficNetwork", "2", "1"));
		list.add(new Item("TrafficNetwork", "FFClose", "TrafficNetwork", "3", "1"));
		list.add(new Item("ConvectionNetwork", "Natural", "ConvectionNetwork", "1", "1"));
		list.add(new Item("ConvectionNetwork", "MixMech", "ConvectionNetwork", "2", "1"));
		list.add(new Item("RadiationNetwork", "Connect", "RadiationNetwork", "1", "1"));
		list.add(new Item("RadiationNetwork", "Transparent", "RadiationNetwork", "2", "1"));
		list.add(new Item("LUDistribution", "Normal", "LUDistribution", "1", "1"));
		list.add(new Item("LUDistribution", "Backup", "LUDistribution", "2", "1"));
		list.add(new Item("HUDistribution", "Normal", "HUDistribution", "1", "1"));
		list.add(new Item("HUDistribution", "Backup", "HUDistribution", "2", "1"));
		list.add(new Item("ChillWaterLoop", "Supply", "ChillWaterLoop", "1", "1"));
		list.add(new Item("ChillWaterLoop", "Return", "ChillWaterLoop", "2", "1"));
		list.add(new Item("ChillWaterLoop", "Bypass", "ChillWaterLoop", "3", "1"));
		list.add(new Item("ChillWaterLoop", "Fill", "ChillWaterLoop", "4", "1"));
		list.add(new Item("CoolingWaterLoop", "Supply", "CoolingWaterLoop", "1", "1"));
		list.add(new Item("CoolingWaterLoop", "Return", "CoolingWaterLoop", "2", "1"));
		list.add(new Item("CoolingWaterLoop", "Bypass", "CoolingWaterLoop", "3", "1"));
		list.add(new Item("CoolingWaterLoop", "Fill", "CoolingWaterLoop", "4", "1"));
		list.add(new Item("HeatWaterLoop", "Supply", "HeatWaterLoop", "1", "1"));
		list.add(new Item("HeatWaterLoop", "Return", "HeatWaterLoop", "2", "1"));
		list.add(new Item("HeatWaterLoop", "Bypass", "HeatWaterLoop", "3", "1"));
		list.add(new Item("HeatWaterLoop", "Fill", "HeatWaterLoop", "4", "1"));
		list.add(new Item("CondWaterNetwork", "Discharge", "CondWaterNetwork", "1", "1"));
		list.add(new Item("ACAirNetwork", "Supply", "ACAirNetwork", "1", "1"));
		list.add(new Item("ACAirNetwork", "Return", "ACAirNetwork", "2", "1"));
		list.add(new Item("FreshAirNetwork", "Fresh", "FreshAirNetwork", "1", "1"));
		list.add(new Item("VentNetwork", "Supply", "VentNetwork", "1", "1"));
		list.add(new Item("VentNetwork", "Discharge", "VentNetwork", "2", "1"));
		list.add(new Item("VentNetwork", "Uncertain", "VentNetwork", "3", "1"));
		list.add(new Item("VRFNetwork", "SupplyReturn", "VRFNetwork", "1", "1"));
		list.add(new Item("DomesticWaterNetwork", "Supply", "SupplyWaterNetwork", "1", "1"));
		list.add(new Item("DomesticWaterNetwork", "Bypass", "SupplyWaterNetwork", "2", "1"));
		list.add(new Item("DrainingWaterNetwork", "Discharge", "DrainingWaterNetwork", "1", "1"));
		list.add(new Item("DrainingWaterNetwork", "Bypass", "DrainingWaterNetwork", "2", "1"));
		list.add(new Item("RecycleWaterNetwork", "Supply", "RecycleWaterNetwork", "1", "1"));
		list.add(new Item("RecycleWaterNetwork", "Bypass", "RecycleWaterNetwork", "2", "1"));
		list.add(new Item("DrinkingWaterNetwork", "Supply", "DrinkingWaterNetwork", "1", "1"));
		list.add(new Item("DrinkingWaterNetwork", "Bypass", "DrinkingWaterNetwork", "2", "1"));
		list.add(new Item("DHWNetwork", "Supply", "DHWNetwork", "1", "1"));
		list.add(new Item("DHWNetwork", "Bypass", "DHWNetwork", "2", "1"));
		list.add(new Item("GasNetwork", "Supply", "GasNetwork", "1", "1"));
		list.add(new Item("GasNetwork", "Bypass", "GasNetwork", "2", "1"));
		list.add(new Item("FireWaterNetwork", "Supply", "FireWaterNetwork", "1", "1"));
		list.add(new Item("FireWaterNetwork", "Bypass", "FireWaterNetwork", "2", "1"));
		list.add(new Item("FireVentNetwork", "Discharge", "FireVentNetwork", "1", "1"));
		list.add(new Item("WENetwork", "Normal", "SensorNetwork", "1", "1"));
		list.add(new Item("MechInArch", "Eq2Bd", "Subset", "3", "0"));
		list.add(new Item("MechInArch", "Eq2Fl", "EquipinFloor", "1", "1"));

		list.add(new Item("MechCtrl", "EqCtrl", "ControlRelation", "1", "1"));
		list.add(new Item("MechPower", "EqNormal", "EquipPower", "1", "1"));
		list.add(new Item("MechPower", "EqBackup", "EquipPower", "2", "1"));

		list.add(new Item("Property2Mech", "Pe2Eq", "Pe2Eq", "1", "1"));
		list.add(new Item("PropertyInArch", "Pe2Bd", "Subset", "6", "0"));
		list.add(new Item("PropertyInArch", "Pe2Fl", "Subset", "7", "0"));
		list.add(new Item("SubE", "Sub2Sub", "SubE", "1", "1"));
		list.add(new Item("SubE", "Mt2Sub", "SubE", "2", "1"));
		list.add(new Item("SubE", "Br2Sub", "SubE", "3", "1"));
		list.add(new Item("SubE", "Un2Sub", "SubE", "4", "1"));
		list.add(new Item("SubC", "Sub2Sub", "SubC", "1", "1"));
		list.add(new Item("SubC", "Mt2Sub", "SubC", "2", "1"));
		list.add(new Item("SubC", "Br2Sub", "SubC", "3", "1"));
		list.add(new Item("SubC", "Un2Sub", "SubC", "4", "1"));
		list.add(new Item("SubH", "Sub2Sub", "SubH", "1", "1"));
		list.add(new Item("SubH", "Mt2Sub", "SubH", "2", "1"));
		list.add(new Item("SubH", "Br2Sub", "SubH", "3", "1"));
		list.add(new Item("SubH", "Un2Sub", "SubH", "4", "1"));
		list.add(new Item("SubW", "Sub2Sub", "SubW", "1", "1"));
		list.add(new Item("SubW", "Mt2Sub", "SubW", "2", "1"));
		list.add(new Item("SubW", "Br2Sub", "SubW", "3", "1"));
		list.add(new Item("SubW", "Un2Sub", "SubW", "4", "1"));
		list.add(new Item("SubG", "Sub2Sub", "SubG", "1", "1"));
		list.add(new Item("SubG", "Mt2Sub", "SubG", "2", "1"));
		list.add(new Item("SubG", "Br2Sub", "SubG", "3", "1"));
		list.add(new Item("SubG", "Un2Sub", "SubG", "4", "1"));
		list.add(new Item("SubF", "Sub2Sub", "SubF", "1", "1"));
		list.add(new Item("SubF", "Mt2Sub", "SubF", "2", "1"));
		list.add(new Item("SubF", "Br2Sub", "SubF", "3", "1"));
		list.add(new Item("SubF", "Un2Sub", "SubF", "4", "1"));
		list.add(new Item("SubV", "Sub2Sub", "SubV", "1", "1"));
		list.add(new Item("SubV", "Mt2Sub", "SubV", "2", "1"));
		list.add(new Item("SubV", "Br2Sub", "SubV", "3", "1"));
		list.add(new Item("SubV", "Un2Sub", "SubV", "4", "1"));
		list.add(new Item("EnergyMonitorStructure", "Mt2Br", "EnergyMonitorStructure", "2", "1"));
		list.add(new Item("EnergyMonitorStructure", "Mt2Un", "EnergyMonitorStructure", "3", "1"));
		list.add(new Item("EnergyMonitorStructure", "Br2Un", "EnergyMonitorStructure", "4", "1"));
		list.add(new Item("VRFNetwork", "SupplyReturn", "VRFNetwork", "2", "0"));
		list.add(new Item("WENetwork", "Normal", "ControlEquipNetwork", "1", "1"));
		list.add(new Item("PropertyInArch", "Pe2Bd", "Pe2Bd", "1", "1"));
		list.add(new Item("PropertyInArch", "Pe2Fl", "Pe2Fl", "1", "1"));
		list.add(new Item("SubE", "Sub2Sub", "EnergyItemTree", "1", "1"));
		list.add(new Item("EnergyMonitorStructure", "Mt2Br", "EnergyMonitorStructure", "1", "1"));
		return list;
	}

	private static List<Item> getOldMappingListWithRelValue(){
		List<Item> list = new LinkedList<>();
		list.add(new Item("EquipGroup", "Eq2Eq"));
		list.add(new Item("MechInArch", "Eq2Sp", "EquipinSpace", "1", "1"));
		list.add(new Item("MechForArch", "Eq2Sp", "EquipforSpace", "1", "1"));

		list.add(new Item("MechInArch", "Eq2Sp", "PowerSupplyZone", "EquipinSpace", "100", "1"));
		list.add(new Item("MechInArch", "Eq2Sp", "LightingZone", "EquipinSpace", "200", "1"));
		list.add(new Item("MechInArch", "Eq2Sp", "NetworkZone", "EquipinSpace", "300", "1"));
		list.add(new Item("MechInArch", "Eq2Sp", "AirConditioningZone", "EquipinSpace", "400", "1"));
		list.add(new Item("MechInArch", "Eq2Sp", "HeatingZone", "EquipinSpace", "500", "1"));
		list.add(new Item("MechInArch", "Eq2Sp", "CleanZone", "EquipinSpace", "600", "1"));
		list.add(new Item("MechInArch", "Eq2Sp", "DomesticWaterSupplyZone", "EquipinSpace", "700", "1"));
		list.add(new Item("MechInArch", "Eq2Sp", "FireZone", "EquipinSpace", "800", "1"));
		list.add(new Item("MechInArch", "Eq2Sp", "SecurityZone", "EquipinSpace", "900", "1"));
		list.add(new Item("MechInArch", "Eq2Sp", "TenantZone", "EquipinSpace", "1000", "1"));
		list.add(new Item("MechInArch", "Eq2Sp", "FunctionZone", "EquipinSpace", "1100", "1"));
		list.add(new Item("MechForArch", "Eq2Sp", "PowerSupplyZone", "EquipforSpace", "100", "1"));
		list.add(new Item("MechForArch", "Eq2Sp", "LightingZone", "EquipforSpace", "200", "1"));
		list.add(new Item("MechForArch", "Eq2Sp", "NetworkZone", "EquipforSpace", "300", "1"));
		list.add(new Item("MechForArch", "Eq2Sp", "AirConditioningZone", "EquipforSpace", "400", "1"));
		list.add(new Item("MechForArch", "Eq2Sp", "HeatingZone", "EquipforSpace", "500", "1"));
		list.add(new Item("MechForArch", "Eq2Sp", "CleanZone", "EquipforSpace", "600", "1"));
		list.add(new Item("MechForArch", "Eq2Sp", "DomesticWaterSupplyZone", "EquipforSpace", "700", "1"));
		list.add(new Item("MechForArch", "Eq2Sp", "FireZone", "EquipforSpace", "800", "1"));
		list.add(new Item("MechForArch", "Eq2Sp", "SecurityZone", "EquipforSpace", "900", "1"));
		list.add(new Item("MechForArch", "Eq2Sp", "TenantZone", "EquipforSpace", "1000", "1"));
		list.add(new Item("MechForArch", "Eq2Sp", "FunctionZone", "EquipforSpace", "1100", "1"));
		return list;
	}

	public static Item getMapping(String graph, String relCode) {
		for (Item mapping : mappings) {
			if (mapping.oldGraph.equals(graph) && (mapping.oldRelcode.equalsIgnoreCase(relCode))) {
				return mapping;
			}
		}
		return null;
	}

	@Getter
	@Setter
	public static class Item {
		private String newGraph;
		private String newRelcode;
		private String newRelValue;
		private String oldGraph;
		private String oldRelcode;
		private Boolean same;

		public Item(String newGraph, String newRelcode) {
			this(newGraph, newRelcode, newGraph, newRelcode, "1");
		}

		public Item(String newGraph, String newRelcode, String oldGraph, String oldRelcode, String same) {
			this(newGraph, newRelcode, null, oldGraph, oldRelcode, same);
		}

		public Item(String newGraph, String newRelcode, String newRelValue, String oldGraph, String oldRelcode, String same) {
			this.newGraph = newGraph;
			this.newRelcode = newRelcode;
			this.newRelValue = newRelValue;
			this.oldGraph = oldGraph;
			this.oldRelcode = oldRelcode;
			this.same = "1".equalsIgnoreCase(same);
		}
	}


}
