package com.persagy.dmp.rwd.config;

import lombok.Data;
import org.springframework.web.servlet.ModelAndView;
import org.springframework.web.servlet.handler.HandlerInterceptorAdapter;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
 * @author: yaoll
 * @date: 2020-12-20
 * @verison: 1.0
 */
public class JpaSqlExecuteContext extends HandlerInterceptorAdapter {

	private static final ThreadLocal<Param> param = new ThreadLocal();

	@Override
	public boolean preHandle(HttpServletRequest request, HttpServletResponse response, Object handler) throws Exception {
		this.init(request.getParameter("groupCode"), request.getParameter("projectId"));
		return true;
	}

	@Override
	public void postHandle(HttpServletRequest request, HttpServletResponse response, Object handler, ModelAndView modelAndView) throws Exception {
		this.clear();
	}

	@Override
	public void afterCompletion(HttpServletRequest request, HttpServletResponse response, Object handler, Exception ex) throws Exception {
		this.clear();
	}


	@Data
	public static class Param {
		private String groupCode;
		private String projectId;
	}

	public static void init(String groupCode, String projectId) {
		if (param.get() == null) {
			param.set(new Param());
		}
		param.get().groupCode = groupCode;
		param.get().projectId = projectId;
	}

	public static void clear() {
		param.remove();
		param.set(null);
	}

	public static String getGroupCode() {
		return param.get().groupCode;
	}

	public static String getProjectId() {
		return param.get().projectId;
	}

}
